#!/usr/bin/env node

var program = require('commander');
var chalk = require('chalk');
var start = require('../src/start');
var build = require('../src/build');
var lint = require('../src/lint');
var test = require('../src/test');

program
  .version('0.0.1')

program
  .command('start')
  .description('start dev server')
  .option("-p, --port [port]", "dev server port")
  .option("-H, --hmr", "hmr")
  .action(function(options){
    var port = options.port || 8181;
    var hmr = options.hmr;
    start({
      port: port,
      hmr: hmr ? true : false
    });
  });

program
  .command('build')
  .description('build project')
  .action(function(env, options){
    build();
  });

program
  .command('lint')
  .description('run eslint')
  .action(function(env, options){
    lint();
  });

program
  .command('test')
  .description('run test')
  .action(function(env, options){
    test();
  });

program.parse(process.argv);