var HtmlWebpackPlugin = require('html-webpack-plugin');

module.exports = function(webpackConfig, webpack, type) {
  //删除 plugins 中默认的CommonsChunkPlugin插件
  webpackConfig.plugins = webpackConfig.plugins.filter((plugin, i) => {
    if(plugin instanceof webpack.optimize.CommonsChunkPlugin) {
      return false;
    } else {
      return true;
    }
  });
  // 优化打包速度
  webpackConfig.babel.plugins.push('transform-runtime');
  webpackConfig.babel.plugins.push(['antd', {}]);

  if (type === 'build') {
    webpackConfig.plugins.push(
      new HtmlWebpackPlugin({
        template: './build.html',
        filename: 'index.html',
        inject: 'body'
      })
    );
  }

  return Object.assign({}, webpackConfig, {
    // entry: Object.assign({}, webpackConfig.entry, {
    //   antd: ['antd'],
    //   jquery: ['jquery']
    // }),
    plugins: webpackConfig.plugins.concat([
      new webpack.IgnorePlugin(/^\.\/locale$/, /moment$/),
      new webpack.DefinePlugin({
        TYPE: JSON.stringify('master')
      }),
      new webpack.ProvidePlugin({
        ReactDOM: 'react-dom',
        React: 'react',
        $: 'jquery',
        jQuery: "jquery",
        "window.jQuery": "jquery",
        "_": 'lodash'
      })/*,
      new webpack.optimize.CommonsChunkPlugin({
        names: ['antd','jquery'],
        minChunks: Infinity
      })*/
    ])
  });
};